#include <bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second
#define int long long

using namespace std;

const int INF=numeric_limits<int>::max();

int resi(const vector<int>& v, int l, int r){
    int maks=0ll;
    int k=0ll;
    set<int> s;
    for(int i=32ll;i>=0ll;i--){
        k=k|(1ll<<i);
        for(int j=l;j<=r;j++){
            s.insert(v[j]&k);
        }
        int ans=maks|(1ll<<i);
        for(int a:s){
            if(s.count(a^ans)>0ll){
                maks=ans;
                break;
            }
        }
        s.clear();
    }
    return maks;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin>>n;
    vector<int> a(n);
    vector<int> b(n);
    for(int i=0;i<n;i++)cin>>a[i];
    for(int i=0;i<n;i++)cin>>b[i];
    bool bok=true;
    for(int i=0;i<n;i++)if(b[i]>3)bok=false;
    bool aok=true;
    for(int i=0;i<n;i++)if(a[i]!=1)aok=false;

    if(n<=2000){
        int ans=0ll;
        int x=0ll;
        int an=(1ll<<32)-1ll;
        for(int i=0;i<n;i++){
            x=0ll;
            an=(1ll<<32)-1ll;
            for(int j=i;j<n;j++){
                x^=a[j];
                an&=b[j];
                ans=max(ans,x*an);
            }
        }
        cout<<ans<<endl;
    }
    else if(bok){
        int ans=0ll;
        vector<int> pref(n+1);
        pref[0]=0ll;
        for(int i=0;i<n;i++){
            pref[i+1ll]=pref[i]^a[i];
        }
        for(int i=1;i<=3;i++){
            int pos=0ll;
            int l=-1ll;
            int r=-1ll;
            while(pos<n){
                if((i&b[pos])!=i)pos++;
                else{
                    l=pos;
                    while(pos+1<n && (b[pos+1]&i)==i)pos++;
                    r=pos;
                    ans=max(ans,i*resi(pref,l,r+1));
                    pos++;
                }
            }
        }
        cout<<ans<<endl;
    }
    
    else if(aok){
        int ans=0ll;
        for(int i=0;i<n;i++){
            ans=max(ans,b[i]);
        }
        cout<<ans<<endl;
    }


    return 0;
}